unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: David Bremner <david@tethera.net>
To: David Bremner <david@tethera.net>, notmuch@notmuchmail.org
Subject: [PATCH 3/9] cli/config: support user header index config
Date: Sun, 28 Apr 2019 20:10:43 -0300	[thread overview]
Message-ID: <20190428231049.15737-4-david@tethera.net> (raw)
In-Reply-To: <20190428231049.15737-1-david@tethera.net>

We don't do anything with this configuration information information
yet, but nonetheless add a couple of regression tests to make sure we
don't break standard functionality when we do use the configuration
information.
---
 notmuch-config.c         |  1 +
 test/T750-user-header.sh | 43 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 44 insertions(+)
 create mode 100755 test/T750-user-header.sh

diff --git a/notmuch-config.c b/notmuch-config.c
index daecbdac..519fb27d 100644
--- a/notmuch-config.c
+++ b/notmuch-config.c
@@ -831,6 +831,7 @@ typedef struct config_key {
 static struct config_key
 config_key_table[] = {
     {"index.decrypt",	true,	false,	NULL},
+    {"index.header.",	true,	true,	NULL},
     {"query.",		true,	true,	NULL},
 };
 
diff --git a/test/T750-user-header.sh b/test/T750-user-header.sh
new file mode 100755
index 00000000..75fb1635
--- /dev/null
+++ b/test/T750-user-header.sh
@@ -0,0 +1,43 @@
+#!/usr/bin/env bash
+test_description='indexing user specified headers'
+. $(dirname "$0")/test-lib.sh || exit 1
+
+test_begin_subtest "error adding user header before initializing DB"
+notmuch config set index.header.List List-Id 2>&1 | notmuch_dir_sanitize > OUTPUT
+cat <<EOF > EXPECTED
+Error opening database at MAIL_DIR/.notmuch: No such file or directory
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+add_email_corpus
+
+notmuch search '*' | notmuch_search_sanitize > initial-threads
+notmuch search --output=messages '*' > initial-message-ids
+notmuch dump > initial-dump
+
+test_begin_subtest "adding user header"
+test_expect_code 0 "notmuch config set index.header.List \"List-Id\""
+
+test_begin_subtest "adding existing user header"
+test_expect_code 0 "notmuch config set index.header.List \"List-Id\""
+
+
+test_begin_subtest "retrieve user header"
+output=$(notmuch config get index.header.List)
+test_expect_equal "List-Id" "$output"
+
+test_begin_subtest 'reindex after adding header preserves threads'
+notmuch reindex '*'
+notmuch search '*' | notmuch_search_sanitize > OUTPUT
+test_expect_equal_file initial-threads OUTPUT
+
+test_begin_subtest "List all user headers"
+notmuch config set index.header.Spam "X-Spam"
+notmuch config list | grep ^index.header | notmuch_config_sanitize > OUTPUT
+cat <<EOF > EXPECTED
+index.header.List=List-Id
+index.header.Spam=X-Spam
+EOF
+test_expect_equal_file EXPECTED OUTPUT
+
+test_done
-- 
2.20.1

  parent reply	other threads:[~2019-04-28 23:10 UTC|newest]

Thread overview: 22+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-03-27 11:16 Index user defined headers David Bremner
2019-03-27 11:16 ` [PATCH 1/9] util: add unicode_word_utf8 David Bremner
2019-03-27 11:16 ` [PATCH 2/9] cli/config: refactor _stored_in_db David Bremner
2019-03-27 11:16 ` [PATCH 3/9] cli/config: support user header index config David Bremner
2019-03-27 11:16 ` [PATCH 4/9] cli/config: check syntax of user configured field names David Bremner
2019-03-27 11:16 ` [PATCH 5/9] lib: setup user headers in query parser David Bremner
2019-03-27 11:16 ` [PATCH 6/9] lib: cache user prefixes in database object David Bremner
2019-03-27 11:16 ` [PATCH 7/9] lib: support user prefix names in term generation David Bremner
2019-03-27 11:16 ` [PATCH 8/9] lib/database: index user headers David Bremner
2019-03-27 11:16 ` [PATCH 9/9] doc: document user header indexing David Bremner
2019-04-26 11:15 ` Index user defined headers David Bremner
2019-05-25 10:38   ` David Bremner
2019-04-28 23:10 ` Index user defined headers v2 David Bremner
2019-04-28 23:10   ` [PATCH 1/9] util: add unicode_word_utf8 David Bremner
2019-04-28 23:10   ` [PATCH 2/9] cli/config: refactor _stored_in_db David Bremner
2019-04-28 23:10   ` David Bremner [this message]
2019-04-28 23:10   ` [PATCH 4/9] cli/config: check syntax of user configured field names David Bremner
2019-04-28 23:10   ` [PATCH 5/9] lib: setup user headers in query parser David Bremner
2019-04-28 23:10   ` [PATCH 6/9] lib: cache user prefixes in database object David Bremner
2019-04-28 23:10   ` [PATCH 7/9] lib: support user prefix names in term generation David Bremner
2019-04-28 23:10   ` [PATCH 8/9] lib/database: index user headers David Bremner
2019-04-28 23:10   ` [PATCH 9/9] doc: document user header indexing David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190428231049.15737-4-david@tethera.net \
    --to=david@tethera.net \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).